%global install_loc    %{_datadir}/eclipse/dropins/jgit
%global version_suffix 201310021548-r

%{?scl:%scl_package eclipse-jgit}
%{!?scl:%global pkg_name %{name}}


Name:           %{?scl_prefix}eclipse-jgit
Version:        3.1.0
Release:        %mkrel 3
Summary:        Eclipse JGit

Group:          Development/Java
License:        BSD
URL:            http://www.eclipse.org/egit/
Source0:        http://git.eclipse.org/c/jgit/jgit.git/snapshot/jgit-%{version}.%{version_suffix}.tar.bz2
Patch0:         fix_jgit_sh.patch
Patch1:			eclipse-jgit-413163.patch

BuildArch: noarch

BuildRequires: java-devel
BuildRequires: %{?scl_prefix}eclipse-pde >= 1:3.5.0
BuildRequires:  jpackage-utils
BuildRequires:  maven-local
BuildRequires:  maven-compiler-plugin
BuildRequires:  maven-install-plugin
BuildRequires:  maven-jar-plugin
BuildRequires:  maven-javadoc-plugin
BuildRequires:  maven-release-plugin
BuildRequires:  maven-resources-plugin
BuildRequires:  maven-surefire-plugin
BuildRequires:  maven-surefire-provider-junit
BuildRequires:  maven-shade-plugin
BuildRequires:  tycho
BuildRequires:  eclipse-equinox-osgi
BuildRequires:  eclipse-platform
BuildRequires:  args4j >= 2.0.12
BuildRequires:  apache-commons-compress
BuildRequires:  xz-java >= 1.1-2
BuildRequires:  javaewah
BuildRequires:  mvn(org.codehaus.mojo:build-helper-maven-plugin)
BuildRequires:  feclipse-maven-plugin >= 0.0.3
%{?scl:Requires: %scl_runtime}
Requires: %{?scl_prefix}eclipse-platform >= 3.5.0
Requires:  javaewah

%description
A pure Java implementation of the Git version control system.

%package -n     %{?scl_prefix}jgit-javadoc
Summary:        API documentation for %{pkg_name}
Group:          Documentation
Requires:       jpackage-utils

%description -n %{?scl_prefix}jgit-javadoc
%{summary}.

%package -n     %{?scl_prefix}jgit
Summary:        Java-based command line Git interface
Group:          Development/Java
Requires:       args4j >= 2.0.12
Requires:       java >= 1.6.0
Requires:       apache-commons-compress
Requires:       xz-java >= 1.1-2
Requires:       jpackage-utils
Requires:       javaewah

%description -n %{?scl_prefix}jgit
Command line Git tool built entirely in Java.

%prep
%setup -n jgit-%{version}.%{version_suffix} -q

%patch0
%patch1 -p1

#javaevah change
sed -i -e 's/javaewah/com.googlecode.javaewah/g' org.eclipse.jgit/META-INF/MANIFEST.MF
find -name *.java -exec sed -i -e "s/javaewah/com.googlecode.javaewah/g" {} \;
sed -i -e "s/javaewah/com.googlecode.javaewah.JavaEWAH/g" org.eclipse.jgit.packaging/org.eclipse.jgit.feature/feature.xml

#don't try to get it from local *maven* repo, use tycho resolved one
%pom_remove_dep com.googlecode.javaewah:JavaEWAH

#those bundles don't compile with latest jetty
%pom_disable_module org.eclipse.jgit.http.test
%pom_disable_module org.eclipse.jgit.pgm.test
%pom_disable_module org.eclipse.jgit.junit.http
%pom_remove_dep : org.eclipse.jgit.packaging/org.eclipse.jgit.repository

%pom_disable_module org.eclipse.jgit.target org.eclipse.jgit.packaging
%pom_xpath_remove "pom:build/pom:pluginManagement/pom:plugins/pom:plugin/pom:configuration/pom:target" org.eclipse.jgit.packaging/pom.xml

%pom_disable_module org.eclipse.jgit.java7.feature org.eclipse.jgit.packaging
%pom_disable_module org.eclipse.jgit.source.feature org.eclipse.jgit.packaging
%pom_disable_module org.eclipse.jgit.junit.feature org.eclipse.jgit.packaging
%pom_disable_module org.eclipse.jgit.pgm.feature org.eclipse.jgit.packaging
%pom_disable_module org.eclipse.jgit.pgm.source.feature org.eclipse.jgit.packaging

# remove all features except for jgit
sed -i -e '9,23d' org.eclipse.jgit.packaging/org.eclipse.jgit.repository/category.xml

sed -i -e 's/\, multiValued = true//' org.eclipse.jgit.pgm/src/org/eclipse/jgit/pgm/Status.java

%build
%{?scl:%scl_maven_opts}
mvn-rpmbuild -Dmaven.test.skip=true install
mvn-rpmbuild -Dmaven.test.skip=true -f org.eclipse.jgit.packaging/pom.xml verify

%install
install -d -m 755 %{buildroot}%{install_loc}


mvn-rpmbuild org.fedoraproject:feclipse-maven-plugin:install  \
               -DskipTychoVersionCheck \
               -DsourceRepo=`pwd`/org.eclipse.jgit.packaging/org.eclipse.jgit.repository/target/repository \
               -DtargetLocation=%{buildroot}%{install_loc}/eclipse

pushd %{buildroot}%{install_loc}/eclipse/plugins
    rm com.jcraft.jsch_*.jar
    rm com.googlecode.javaewah.JavaEWAH_*.jar
#to the future maintainers - dont forget to add those jars to the fix_jgit_sh.patch
    ln -s %{_javadir}/args4j.jar
    ln -s %{_javadir}/commons-compress.jar
    ln -s %{_javadir}/xz-java.jar
    ln -s %{_javadir}/javaewah/JavaEWAH.jar
popd

#giant hack - for some reason source bundle is in the repo, install the proper one
cp org.eclipse.jgit/target/org.eclipse.jgit-*-r.jar %{buildroot}%{install_loc}/eclipse/plugins 

# JARs
install -d -m 0755 %{buildroot}%{_javadir}/jgit
install -m 644 org.eclipse.jgit/target/org.eclipse.jgit-%{version}.%{version_suffix}.jar   %{buildroot}%{_javadir}/jgit/jgit.jar
install -m 644 org.eclipse.jgit.ui/target/org.eclipse.jgit.ui-%{version}.%{version_suffix}.jar   %{buildroot}%{_javadir}/jgit/ui.jar
install -m 644 org.eclipse.jgit.java7/target/org.eclipse.jgit.java7-%{version}.%{version_suffix}.jar   %{buildroot}%{_javadir}/jgit/java7.jar
install -m 644 org.eclipse.jgit.console/target/org.eclipse.jgit.console-%{version}.%{version_suffix}.jar   %{buildroot}%{_javadir}/jgit/console.jar
install -m 644 org.eclipse.jgit.pgm/target/org.eclipse.jgit.pgm-%{version}.%{version_suffix}.jar   %{buildroot}%{_javadir}/jgit/pgm.jar
# Javadocs
install -d -m 755 %{buildroot}%{_javadocdir}/jgit
cp -rp org.eclipse.jgit/target/apidocs %{buildroot}%{_javadocdir}/jgit
cp -rp org.eclipse.jgit.ui/target/apidocs %{buildroot}%{_javadocdir}/jgit
cp -rp org.eclipse.jgit.console/target/apidocs %{buildroot}%{_javadocdir}/jgit
# POM Files
install -d -m 755 %{buildroot}%{_mavenpomdir}
install -pm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-jgit-parent.pom
install -pm 644 org.eclipse.jgit/pom.xml %{buildroot}%{_mavenpomdir}/JPP.jgit-jgit.pom
install -pm 644 org.eclipse.jgit.ui/pom.xml %{buildroot}%{_mavenpomdir}/JPP.jgit-ui.pom
install -pm 644 org.eclipse.jgit.java7/pom.xml %{buildroot}%{_mavenpomdir}/JPP.jgit-java7.pom
install -pm 644 org.eclipse.jgit.console/pom.xml %{buildroot}%{_mavenpomdir}/JPP.jgit-console.pom
install -pm 644 org.eclipse.jgit.pgm/pom.xml %{buildroot}%{_mavenpomdir}/JPP.jgit-pgm.pom

%add_maven_depmap JPP.jgit-jgit.pom jgit/jgit.jar
%add_maven_depmap JPP.jgit-ui.pom jgit/ui.jar
%add_maven_depmap JPP.jgit-java7.pom jgit/java7.jar
%add_maven_depmap JPP.jgit-console.pom jgit/console.jar
%add_maven_depmap JPP.jgit-pgm.pom jgit/pgm.jar
%add_maven_depmap JPP-jgit-parent.pom
# Binary
install -dm 755 %{buildroot}%{_bindir}
install -m 755 org.eclipse.jgit.pgm/jgit.sh %{buildroot}%{_bindir}/jgit

%clean
find . -type d -exec chmod u+rx {} +

%files
%doc LICENSE 
%doc README.md
%{install_loc}

%files -n %{?scl_prefix}jgit
%{_bindir}/jgit
%{_javadir}/jgit
%{_mavendepmapfragdir}/%{name}
%{_mavenpomdir}/JPP-jgit-parent.pom
%{_mavenpomdir}/JPP.jgit*.pom
%doc LICENSE 
%doc README.md

%files -n %{?scl_prefix}jgit-javadoc
%{_javadocdir}/jgit
%doc LICENSE 
%doc README.md




%changelog
* Thu Dec 19 2013 luigiwalser <luigiwalser> 3.1.0-3.mga4
+ Revision: 559006
- rebuild against eclipse-4.3.1-7.mga4

* Tue Oct 22 2013 umeabot <umeabot> 3.1.0-2.mga4
+ Revision: 542181
- Mageia 4 Mass Rebuild

* Mon Oct 14 2013 dmorgan <dmorgan> 3.1.0-1.mga4
+ Revision: 497051
- New version
- New version

* Sat Jan 19 2013 dmorgan <dmorgan> 2.2.0-1.mga3
+ Revision: 389581
- New version

* Fri Jan 11 2013 umeabot <umeabot> 2.1.0-5.mga3
+ Revision: 349434
- Mass Rebuild - https://wiki.mageia.org/en/Feature:Mageia3MassRebuild

* Thu Dec 06 2012 dmorgan <dmorgan> 2.1.0-4.mga3
+ Revision: 327351
- Rebuild against new eclipse
- Rebuild against new eclipse

* Wed Dec 05 2012 dmorgan <dmorgan> 2.1.0-2.mga3
+ Revision: 327059
- Rebuild to check correctness of eclipse setup

* Wed Dec 05 2012 dmorgan <dmorgan> 2.1.0-1.mga3
+ Revision: 326990
- New version
- New version

* Mon May 09 2011 dmorgan <dmorgan> 0.12.1-1.mga1
+ Revision: 96792
- imported package eclipse-jgit

